]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
OpenSwan gefixt.
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.0t5" # Version number
28SLOGAN="www.ipfire.org" # Software slogan
29CONFIG_ROOT=/var/ipfire # Configuration rootdir
30NICE=10 # Nice level
31MAX_RETRIES=1 # prefetch/check loop
32KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33MACHINE=`uname -m`
34SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36IPFVER="full" # Which versions should be compiled? (full|devel)
37
38# Set an information about the build number
39if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41fi
42
43# Debian specific settings
44if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53fi
54
55PWD=`pwd`
56BASENAME=`basename $0`
57BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58LOGFILE=$BASEDIR/log/_build.preparation.log
59export BASEDIR LOGFILE
60DIR_CHK=$BASEDIR/cache/check
61mkdir $BASEDIR/log/ 2>/dev/null
62
63# Include funtions
64. tools/make-functions
65
66if [ -f .config ]; then
67 . .config
68else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76fi
77
78prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213}
214
215buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253}
254
255buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315}
316
317buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 ipfiremake r8169 SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 ipfiremake linux
340 ipfiremake ipp2p
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 ipfiremake r8169
347 ipfiremake zaptel
348 ipfiremake fuse
349 ipfiremake pkg-config
350 ipfiremake cpio
351 ipfiremake klibc
352 ipfiremake mkinitcpio
353 ipfiremake udev KLIBC=1
354 ipfiremake expat
355 ipfiremake gdbm
356 ipfiremake gmp
357 ipfiremake pam
358 ipfiremake openssl
359 ipfiremake curl
360 ipfiremake python
361 ipfiremake libnet
362 ipfiremake libjpeg
363 ipfiremake libpng
364 ipfiremake libtiff
365 ipfiremake libart
366 ipfiremake freetype
367 ipfiremake gd
368 ipfiremake popt
369 ipfiremake pcre
370 ipfiremake slang
371 ipfiremake newt
372 ipfiremake libcap
373 ipfiremake pciutils
374 ipfiremake usbutils
375 ipfiremake libxml2
376 ipfiremake libxslt
377 ipfiremake BerkeleyDB
378 ipfiremake mysql
379 ipfiremake cyrus-sasl
380 ipfiremake openldap
381 ipfiremake apache2
382 ipfiremake php
383 ipfiremake apache2 PASS=C
384 ipfiremake arping
385 ipfiremake beep
386 ipfiremake bind
387 ipfiremake capi4k-utils
388 ipfiremake cdrtools
389 ipfiremake dnsmasq
390 ipfiremake dosfstools
391 ipfiremake squashfstools
392 ipfiremake reiserfsprogs
393 ipfiremake sysfsutils
394 ipfiremake ntfs-3g
395 ipfiremake ethtool
396 ipfiremake ez-ipupdate
397 ipfiremake fcron
398 ipfiremake perl-GD
399 ipfiremake GD-Graph
400 ipfiremake GD-TextUtil
401 ipfiremake gnupg
402 ipfiremake hdparm
403 ipfiremake ibod
404 ipfiremake initscripts
405 ipfiremake whatmask
406 ipfiremake iptables
407 ipfiremake libupnp
408 ipfiremake ipp2p IPT=1
409 ipfiremake moblock
410 ipfiremake linux-igd
411 ipfiremake ipac-ng
412 ipfiremake ipaddr
413 ipfiremake iptstate
414 ipfiremake iputils
415 ipfiremake l7-protocols
416 ipfiremake mISDN
417 ipfiremake isdn4k-utils
418 ipfiremake hwdata
419 ipfiremake kudzu
420 ipfiremake logrotate
421 ipfiremake logwatch
422 ipfiremake misc-progs
423 ipfiremake nano
424 ipfiremake nasm
425 ipfiremake URI
426 ipfiremake HTML-Tagset
427 ipfiremake HTML-Parser
428 ipfiremake Compress-Zlib
429 ipfiremake Digest
430 ipfiremake Digest-SHA1
431 ipfiremake Digest-HMAC
432 ipfiremake libwww-perl
433 ipfiremake Net-DNS
434 ipfiremake Net-IPv4Addr
435 ipfiremake Net_SSLeay
436 ipfiremake IO-Stringy
437 ipfiremake Unix-Syslog
438 ipfiremake Mail-Tools
439 ipfiremake MIME-Tools
440 ipfiremake Net-Server
441 ipfiremake Convert-TNEF
442 ipfiremake Convert-UUlib
443 ipfiremake Archive-Tar
444 ipfiremake Archive-Zip
445 ipfiremake Text-Tabs+Wrap
446 ipfiremake Locale-Country
447 ipfiremake XML-Parser
448 ipfiremake MP3-Info
449 ipfiremake MP3-Tag
450 ipfiremake glib
451 ipfiremake GeoIP
452 ipfiremake fwhits
453 ipfiremake noip_updater
454 ipfiremake ntp
455 ipfiremake openssh
456 ipfiremake openswan
457 ipfiremake pptpclient
458 ipfiremake rrdtool
459 ipfiremake setserial
460 ipfiremake setup
461 ipfiremake snort
462 ipfiremake snortsnarf
463 ipfiremake oinkmaster
464 ipfiremake squid
465 ipfiremake squid-graph
466 ipfiremake squidguard
467 ipfiremake calamaris
468 ipfiremake tcpdump
469 ipfiremake traceroute
470 ipfiremake vlan
471 ipfiremake wireless
472 ipfiremake libsafe
473 ipfiremake pakfire
474 ipfiremake java
475 ipfiremake spandsp
476 ipfiremake lzo
477 ipfiremake openvpn
478 ipfiremake pammysql
479 ipfiremake ghostscript
480 ipfiremake cups
481 ipfiremake samba
482 ipfiremake sudo
483 ipfiremake mc
484 ipfiremake wget
485 ipfiremake bridge-utils
486 ipfiremake screen
487 ipfiremake hddtemp
488 ipfiremake smartmontools
489 ipfiremake htop
490 ipfiremake postfix
491 ipfiremake fetchmail
492 ipfiremake cyrusimap
493 ipfiremake webcyradm
494 ipfiremake mailx
495 ipfiremake clamav
496 ipfiremake spamassassin
497 ipfiremake amavisd
498 ipfiremake alsa
499 ipfiremake mpg123
500 ipfiremake mpfire
501 ipfiremake guardian
502 ipfiremake libmad
503 ipfiremake libogg
504 ipfiremake libvorbis
505 ipfiremake lame
506 ipfiremake sox
507 ipfiremake libshout
508 ipfiremake icecast
509 ipfiremake ices
510 ipfiremake mp3blaster
511 ipfiremake libpri
512 ipfiremake stund
513 ipfiremake asterisk
514 ipfiremake backup
515 ipfiremake gnump3d
516 ipfiremake libsigc++
517 ipfiremake applejuice
518 ipfiremake ocaml
519 ipfiremake mldonkey
520 ipfiremake libtorrent
521 ipfiremake rtorrent
522 ipfiremake ipfireseeder
523 ipfiremake rsync
524 ipfiremake tcpwrapper
525 ipfiremake portmap
526 ipfiremake nfs
527 ipfiremake nmap
528 ipfiremake mbmon
529 ipfiremake iftop
530 ipfiremake ncftp
531 ipfiremake cftp
532 ipfiremake etherwake
533 ipfiremake ethereal
534 ipfiremake tftp-hpa
535 ipfiremake bwm-ng
536 ipfiremake tripwire
537 ipfiremake sysstat
538 ipfiremake vsftpd
539 ipfiremake which
540 ipfiremake lsof
541}
542
543buildinstaller() {
544 # Run installer scripts one by one
545 LOGFILE="$BASEDIR/log/_build.installer.log"
546 export LOGFILE
547 ipfiremake syslinux
548 ipfiremake as86
549 ipfiremake mbr
550 ipfiremake memtest
551 installmake linux-libc-header
552 installmake binutils
553 ipfiremake uClibc PASS=1
554 ipfiremake gcc INST=1
555 installmake uClibc PASS=2
556 installmake gcc INST=2
557 installmake uClibc PASS=3
558 installmake busybox
559 installmake udev
560 installmake slang
561 installmake newt
562 installmake gettext
563 installmake kbd
564 installmake popt
565 installmake sysvinit
566 installmake misc-progs
567 installmake libaal
568 installmake reiser4progs
569 installmake reiserfsprogs
570 installmake sysfsutils
571 installmake util-linux
572 installmake pciutils
573 installmake zlib
574 installmake mtd
575 installmake wget
576 installmake hwdata
577 installmake kudzu
578 installmake installer
579 installmake initrd
580}
581
582buildpackages() {
583 LOGFILE="$BASEDIR/log/_build.packages.log"
584 export LOGFILE
585 echo "... see detailed log in _build.*.log files" >> $LOGFILE
586
587 installmake strip
588
589 # Generating list of packages used
590 echo -n "Generating packages list from logs" | tee -a $LOGFILE
591 rm -f $BASEDIR/doc/packages-list
592 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
593 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
594 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
595 fi
596 done
597 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
598 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
599 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
600 rm -f $BASEDIR/doc/packages-list
601 # packages-list.txt is ready to be displayed for wiki page
602 beautify message DONE
603
604 # Create images for install
605 if [ "$DEVEL" == "1" ]; then
606 ipfiremake cdrom ED=devel
607 fi
608 ipfiremake cdrom ED=full
609
610 # Check if there is a loop device for building in virtual environments
611 if [ -e /dev/loop0 ]; then
612 ipfiremake usb-stick
613 fi
614 ipfiremake pxe
615 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
616
617 ipfirepackages
618
619 # Cleanup
620 stdumount
621 rm -rf $BASEDIR/build/tmp/*
622
623 # Generating total list of files
624 echo -n "Generating files list from logs" | tee -a $LOGFILE
625 rm -f $BASEDIR/log/FILES
626 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
627 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
628 echo "##" >>$BASEDIR/log/FILES
629 echo "## `basename $i`" >>$BASEDIR/log/FILES
630 echo "##" >>$BASEDIR/log/FILES
631 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
632 fi
633 done
634 beautify message DONE
635
636 cd $PWD
637}
638
639ipfirepackages() {
640 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
641 [ -e $BASEDIR/lfs/$i ] && ipfiredist $i
642 done
643 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
644 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
645 rm -rf $BASEDIR/build/install/packages/*
646}
647
648# See what we're supposed to do
649case "$1" in
650build)
651 clear
652 BUILDMACHINE=`uname -m`
653 DEVEL=0
654 if [ "$2" == "--devel" ]; then
655 DEVEL=1
656 fi
657 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
658 #only restore on a clean disk
659 if [ ! -f log/cleanup-toolchain-2-tools ]; then
660 if [ ! -n "$PACKAGE" ]; then
661 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
662 prepareenv
663 buildtoolchain
664 else
665 PACKAGENAME=${PACKAGE%.tar.gz}
666 beautify build_stage "Packaged toolchain compilation"
667 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
668 tar zxf $PACKAGE
669 prepareenv
670 else
671 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
672 fi
673 fi
674 else
675 echo -n "Using installed toolchain" | tee -a $LOGFILE
676 beautify message SKIP
677 prepareenv
678 fi
679
680 beautify build_start
681 beautify build_stage "Building LFS"
682 buildbase
683
684 beautify build_stage "Building IPFire"
685 buildipfire
686
687 # Setzen des IPFire Builds
688 if [ "$FIREBUILD" ]; then
689 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
690 else
691 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
692 fi
693
694 beautify build_stage "Building installer"
695 buildinstaller
696
697 beautify build_stage "Building packages"
698 buildpackages
699 beautify build_end
700 ;;
701shell)
702 # enter a shell inside LFS chroot
703 # may be used to changed kernel settings
704 prepareenv
705 entershell
706 ;;
707changelog)
708 echo -n "Loading new Changelog from SVN: "
709 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
710 beautify message DONE
711 ;;
712clean)
713 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
714 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
715 $LOSETUP -d $i 2>/dev/null
716 done
717 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
718 umount $i
719 done
720 stdumount
721 for i in `seq 0 7`; do
722 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
723 umount /dev/loop${i} 2>/dev/null;
724 losetup -d /dev/loop${i} 2>/dev/null;
725 fi;
726 done
727 rm -rf $BASEDIR/build
728 rm -rf $BASEDIR/cdrom
729 rm -rf $BASEDIR/packages
730 rm -rf $BASEDIR/log
731 if [ -h /tools ]; then
732 rm -f /tools
733 fi
734 beautify message DONE
735 ;;
736downloadsrc)
737 if [ ! -d $BASEDIR/cache ]; then
738 mkdir $BASEDIR/cache
739 fi
740 mkdir -p $BASEDIR/log
741 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
742 FINISHED=0
743 cd $BASEDIR/lfs
744 for c in `seq $MAX_RETRIES`; do
745 if (( FINISHED==1 )); then
746 break
747 fi
748 FINISHED=1
749 cd $BASEDIR/lfs
750 for i in *; do
751 if [ -f "$i" -a "$i" != "Config" ]; then
752 echo -ne "Loading $i"
753 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
754 if [ $? -ne 0 ]; then
755 beautify message FAIL
756 FINISHED=0
757 else
758 if [ $c -eq 1 ]; then
759 beautify message DONE
760 fi
761 fi
762 fi
763 done
764 done
765 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
766 ERROR=0
767 for i in *; do
768 if [ -f "$i" -a "$i" != "Config" ]; then
769 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
770 if [ $? -ne 0 ]; then
771 echo -ne "MD5 difference in lfs/$i"
772 beautify message FAIL
773 ERROR=1
774 fi
775 fi
776 done
777 if [ $ERROR -eq 0 ]; then
778 echo -ne "${BOLD}all files md5sum match${NORMAL}"
779 beautify message DONE
780 else
781 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
782 beautify message FAIL
783 fi
784 cd - >/dev/null 2>&1
785 ;;
786toolchain)
787 clear
788 prepareenv
789 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
790 buildtoolchain
791 BUILDMACHINE=`uname -m`
792 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
793 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
794 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
795 build/{bin,etc,usr/bin,usr/local} \
796 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
797 log >> $LOGFILE
798 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
799 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
800 stdumount
801 ;;
802gettoolchain)
803 BUILDMACHINE=`uname -m`
804 # arbitrary name to be updated in case of new toolchain package upload
805 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
806 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
807 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
808 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
809 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
810 cd $BASEDIR/cache/toolchains
811 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
812 if [ $? -ne 0 ]; then
813 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
814 else
815 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
816 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
817 else
818 exiterror "$PACKAGE.md5 did not match, check downloaded package"
819 fi
820 fi
821 else
822 echo "Toolchain is already downloaded. Exiting..."
823 fi
824 ;;
825othersrc)
826 prepareenv
827 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
828 chroot $LFS /tools/bin/env -i HOME=/root \
829 TERM=$TERM PS1='\u:\w\$ ' \
830 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
831 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
832 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
833 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
834 if [ $? -eq "0" ]; then
835 beautify message DONE
836 else
837 beautify message FAIL
838 fi
839 stdumount
840 ;;
841svn)
842 case "$2" in
843 update|up)
844 # clear
845 echo -ne "Loading the latest source files...\n"
846 if [ $3 ]; then
847 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
848 else
849 svn update | tee -a $PWD/log/_build.svn.update.log
850 fi
851 if [ $? -eq "0" ]; then
852 beautify message DONE
853 else
854 beautify message FAIL
855 exit 1
856 fi
857 echo -ne "Writing the svn-info to a file"
858 svn info > $PWD/svn_status
859 if [ $? -eq "0" ]; then
860 beautify message DONE
861 else
862 beautify message FAIL
863 exit 1
864 fi
865 chmod 755 $0
866 exit 0
867 ;;
868 commit|ci)
869 clear
870 if [ -f /usr/bin/mcedit ]; then
871 export EDITOR=/usr/bin/mcedit
872 fi
873 if [ -f /usr/bin/nano ]; then
874 export EDITOR=/usr/bin/nano
875 fi
876 echo -ne "Selecting editor $EDITOR..."
877 beautify message DONE
878 if [ -e /sbin/yast ]; then
879 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
880 $0 changelog
881 fi
882 fi
883 update_langs
884 svn commit
885 $0 svn up
886 if [ -n "$FTP_CACHE_URL" ]; then
887 $0 uploadsrc
888 fi
889 ;;
890 dist)
891 if [ $3 ]; then
892 SVN_REVISION=$3
893 fi
894 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
895 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
896 exit 0
897 fi
898 echo -en "REV $SVN_REVISION: Downloading..."
899 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
900 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
901 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
902 evaluate 1
903
904 echo -en "REV $SVN_REVISION: Compressing files..."
905 if [ -e ipfire-source/trunk/make.sh ]; then
906 chmod 755 ipfire-source/trunk/make.sh
907 fi
908 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
909 evaluate 1
910 echo -en "REV $SVN_REVISION: Cleaning up..."
911 rm ipfire-source/ -r
912 evaluate 1
913 ;;
914 diff|di)
915 update_langs
916 echo -ne "Make a local diff to last svn revision"
917 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
918 evaluate 1
919 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
920 svn status
921 ;;
922 esac
923 ;;
924uploadsrc)
925 PWD=`pwd`
926 cd $BASEDIR/cache/
927 echo -e "Uploading cache to ftp server:"
928 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
929 for i in *; do
930 if [ "$i" == "toolchains" ]; then continue; fi
931 grep -q $i /tmp/ftplist
932 if [ "$?" -ne "0" ]; then
933 echo -ne "$i"
934 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
935 if [ "$?" -ne "0" ]; then
936 beautify message FAIL
937 fi
938 fi
939 done
940 rm -f /tmp/ftplist
941 cd $PWD
942 exit 0
943 ;;
944upload)
945 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
946 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
947 if [ -z $FTP_ISO_PORT ]; then
948 FTP_ISO_PORT=21
949 fi
950 cat <<EOF > .ftp-commands
951mkdir -p $FTP_ISO_PATH$SVN_REVISION
952mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
953quit
954EOF
955 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
956 rm -f .ftp-commands
957
958 case "$2" in
959 iso)
960 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
961
962 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
963 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
964 if [ -e "$i" ]; then
965 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
966 if [ "$?" -eq "0" ]; then
967 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
968 else
969 echo "There was an error while uploading the file $i to the ftp server."
970 exit 1
971 fi
972 fi
973 done
974 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
975 if [ "$3" = "--with-sources-cd" ]; then
976 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
977 fi
978 ;;
979 paks)
980 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
981 if [ "$?" -eq "0" ]; then
982 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
983 else
984 echo -e "There was an error while uploading the packages to the ftp server."
985 exit 1
986 fi
987 ;;
988 esac
989 ;;
990batch)
991 if [ "$2" = "--background" ]; then
992 batch_script
993 exit $?
994 fi
995 if [ `screen -ls | grep -q ipfire` ]; then
996 echo "Build is already running, sorry!"
997 exit 1
998 else
999 if [ "$2" = "--rebuild" ]; then
1000 export IPFIRE_REBUILD=1
1001 echo "REBUILD!"
1002 else
1003 export IPFIRE_REBUILD=0
1004 fi
1005 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1006 screen -dmS ipfire $0 batch --background
1007 evaluate 1
1008 exit 0
1009 fi
1010 ;;
1011watch)
1012 watch_screen
1013 ;;
1014pxe)
1015 case "$2" in
1016 start)
1017 start_tftpd
1018 ;;
1019 stop)
1020 stop_tftpd
1021 ;;
1022 reload|restart)
1023 reload_tftpd
1024 ;;
1025 esac
1026 exit 0
1027 ;;
1028lang)
1029 update_langs
1030 ;;
1031packages)
1032 case "$2" in
1033 sign)
1034 sign_packages
1035 ;;
1036 esac
1037 ;;
1038"")
1039 clear
1040 svn info
1041 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1042 do
1043 case $name in
1044 "IPFIRE: Downloadsrc")
1045 $0 downloadsrc
1046 ;;
1047 "IPFIRE: Build (silent)")
1048 $0 build-silent
1049 ;;
1050 "IPFIRE: Watch Build")
1051 $0 watch
1052 ;;
1053 "IPFIRE: Batch")
1054 $0 batch
1055 ;;
1056 "IPFIRE: Clean")
1057 $0 clean
1058 ;;
1059 "SVN: Update")
1060 $0 svn update
1061 ;;
1062 "Help")
1063 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1064 cat doc/make.sh-usage
1065 ;;
1066 "LOG: Tail")
1067 tail -f log/_*
1068 ;;
1069 "Exit")
1070 break
1071 ;;
1072 esac
1073 done
1074 ;;
1075config)
1076 make_config
1077 ;;
1078*)
1079 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1080 cat doc/make.sh-usage
1081 ;;
1082esac